//  Unit of TSP Solver
//  Created by GrMikeD, 2000-2003
//  http://kickme.to/GrMikeD
//  GrMikeD@Freemail.gr
unit Counter;

interface

uses
  Windows;

type
 TCounter = class
 private
  fFreq: TLargeInteger;
  fStart: TLargeInteger;
 public
  function ElapsedSecs: string;
  function ElapsedCounts: TLargeInteger;
  procedure StartTimeCount(const InitCount: TLargeInteger = 0);
 end;

implementation

uses
  SysUtils;

{ TCounter }

procedure TCounter.StartTimeCount(const InitCount: TLargeInteger = 0);
begin
  QueryPerformanceFrequency(FFreq);
  QueryPerformanceCounter(FStart);
  Dec(Fstart, InitCount);
end;

function  TCounter.ElapsedCounts: TLargeInteger;
var
  Stop: TLargeInteger;
begin
  QueryPerformanceCounter(Stop);
  Result := Stop - FStart;
end;

function  TCounter.ElapsedSecs: string;
begin
  Result := FloatToStrF(ElapsedCounts / FFreq, ffFixed, 4, 4);
end;

end.
